#ifndef Texture_h
#define Texture_h

#include "UtilsGL.h"
#include "DataBuffer.h"


#include <iostream>

class FrameBuffer;

class Texture {
protected:
	GLuint texID;

	GLuint target;
	Vector3i size;
	GLuint format;
	GLuint intFormat;
	GLuint type;

	void create(GLuint target, const Vector3i &size, GLuint iformat, GLuint eformat=GL_RGBA, GLuint t=GL_UNSIGNED_BYTE, void *data=NULL);

public:
	Texture(GLuint target, const Vector3i &size, GLuint iformat, GLuint eformat=GL_RGBA, GLuint type=GL_UNSIGNED_BYTE, void *data=NULL);
	~Texture();

	Texture(const Texture &t);

	Vector3i getSize() const;
	GLuint getTarget() const;
	void setTarget(GLuint t);
	GLuint getType() const;
	GLuint getFormat() const;
	GLuint getInternalFormat() const;
	int getDataSize() const;
	int getNumElem() const;
	
	GLuint getTextureID() const;
	
	
	void bind() const;
	void unbind() const;

	void setFromFramebuffer();

	void setWrapMode(GLuint m);
	void setFilterMode(GLuint m);


	void getData(DataBuffer *db, GLuint type=0) const;
	void getData(DataBuffer *db, FrameBuffer *fb, GLuint type=0);
	void setData(DataBuffer *db, GLuint type=0) ;

	void getData(void *d, GLuint type=0) const;

	void setData(void *d, GLuint f=0, GLuint type=0, GLuint ta=0);
	
	void setValue(const Vector2i &pos, const Vector4f &val);

	int getOffset(const Vector2i &pos) const;
};
#endif