#include <iostream>
using namespace std;

#include <flowvr/module.h>
using namespace flowvr;


bool triKernel(int i, float *datain, float *dataout){
  bool modif=false;

  if(datain[i]>datain[i+1]){
    dataout[i]=datain[i+1];
    dataout[i+1]=datain[i];
    modif=true;
  }else{
    dataout[i]=datain[i];
    dataout[i+1]=datain[i+1];
  }

  //dataout[i]=dataout[i+1]=0.5;//datain[i];
  //dataout[i+1]=datain[i+1]+0.0001;

  return modif;
}

void tri(int size, float *datain, float *dataout){
  float *data[2];
  data[0]=datain;
  data[1]=dataout;
  
  for(int n=0; n<size+1; n++){    
    for(int i=0; i<size/2 -(n%2); i++){
      triKernel(i*2+(n%2), data[n%2], data[!(n%2)]);
      if(n%2){
	data[0][0]=data[1][0];
	data[0][size-1]=data[1][size-1];
      }
    }
    
  }
}

bool triStep(int size, int n, float *data[2]){
  bool modif=false;

  for(int i=0; i<size/2 -(n%2); i++){
    bool lmod;
    lmod=triKernel(i*2+(n%2), data[n%2], data[!(n%2)]);
    modif=modif || lmod;

    if(n%2){
      data[0][0]=data[1][0];
      data[0][size-1]=data[1][size-1];
    }
  }

  // for(int i=0; i<size; i++)
  //  data[!(n%2)][i]=0.5;

  return modif;

}



int main(int argc, char* argv[]) {

  vector<Port*> ports;
  ModuleAPI* module;

  int localsize;
  float* localtab;
  float* sendtab;

  int sortLoop=0;

  InputPort* inport = new InputPort("inputtab");
  ports.push_back(inport);


  OutputPort* outport = new OutputPort("outputtab");
  ports.push_back(outport);

  module = flowvr::initModule(ports);

  if(module) {

    Message messagein;

    MessageWrite messageout;

    // Create a pool of buffers :
    ///flowvr::BufferPool *pOutPool = new flowvr::BufferPool();
    

    bool modif=true;
    float *data[2];
    float *restab=NULL;//=new float[localsize];
    float *restab2=NULL;//=new float[localsize];

    //Nouveau tableau a trier
    while(module->wait()) {

      //Rcupration du tableau global
      module->get(inport, messagein);

      //Tu rcuperes la taille du tableau en octets donc division par sizeof(int)
      localsize = messagein.data.getSize()/sizeof(float);

      cout << "localsize=" << localsize << endl;


      
      //Recuperation d'un pointeur vers les donnes recues (attention const float*)
      localtab = messagein.data.getRead<float>(0);

#if 1
      //Tu dois allouer une zone memoire pour le message a emettre (le tableau trie) 
      //CC: A chaque fois ??
      messageout.data=module->alloc(localsize*sizeof(float));
	  
      //Ensuite tu peux ecrire dedans et manipuler le contenu avec le tri.
      sendtab = messageout.data.getWrite<float>(0);
    

	if(restab)
	  delete [] restab;
	if(restab2)
	  delete [] restab2;
	restab=new float[localsize];
	restab2=new float[localsize];

	/*data[0]=localtab;
	data[1]=restab;
	///}else{

	//      do{
	triStep(localsize, 0, data);

	data[0]=restab2;
	data[1]=restab;
	modif=modif || triStep(localsize, 1, data);

	memcpy(sendtab, restab2, localsize*sizeof(float));*/

	//	data[(sortLoop%2)]=localtab;
	//data[!(sortLoop%2)]=sendtab;

	//	data[0]=localtab;
	//data[1]=sendtab;

      memcpy(restab, localtab, localsize*sizeof(float));
      // memcpy(restab2, localtab, localsize*sizeof(float));

      //      data[0]=restab;
      //data[1]=restab2;
      data[sortLoop%2]=restab;
      data[!(sortLoop%2)]=restab2;

      //      do{
	
      //      for(int k=0; k<10000; k++){
	//data[sortLoop%2]=restab;
	//data[!(sortLoop%2)]=sendtab;

        //data[sortLoop%2]=localtab;
        //data[!(sortLoop%2)]=sendtab;

	modif=triStep(localsize,sortLoop, data);

	sortLoop++;

	modif=triStep(localsize,sortLoop, data);

	sortLoop++;
	
	///if((sortLoop%10)==0){
	  //Tu dois allouer une zone memoire pour le message a emettre (le tableau trie) 
	  //CC: A chaque fois ??
	  /*messageout.data=pOutPool->alloc(module, localsize*sizeof(float));
	  
	  //Ensuite tu peux ecrire dedans et manipuler le contenu avec le tri.
	  sendtab = messageout.data.getWrite<float>(0);*/

	 memcpy(sendtab, data[sortLoop%2], localsize*sizeof(float));

	  //Envoi du tableau global
	  module->put(outport, messageout);
	  ///}

	
	//sleep(1);
	//      }while(1);
	  ///}

#endif

    }

    module->close();
  }
  else {
    cerr << "Erreur d'initialisation" << endl;
  }

  return 0;

}
