#ifndef GLAppParallelSort_h
#define GLAppParallelSort_h

#include "GLApp.h"
#include <iostream>
#include <time.h>
#include <math.h>
#include "Texture.h"
#include "ShaderObjectCg.h"

#include "l3ds.h"

using namespace UtilsGL;

/** Main class for GPU 3D fluid simulation.*/
class GLAppParallelSort : public GLApp {

	//Mouse control
	Vector2i oldMousePos;
	bool mouseButtons[3];

	//general flags
	bool pause;
	bool wireframe;
	bool reset;

	//int manipMode;
	Vector3f viewOrient;
	Vector3f viewPos;

	int TSIZE;
	Vector3i domSize;

	L3DS objet3DS;
	L3DS prod3DS;

	Texture *texSolution;
	Texture *texGrads;

	float *data[3];
	int sortLoop;

	ShaderObjectCg *dispShader;
	ShaderObjectCg *becherShader;

	bool perturb;

	std::string mediapath;

protected:
	virtual void keyboard(unsigned char key);
	virtual void mouse(int button, int state, int x, int y);
	virtual void mouseMove(int x, int y);
	virtual void mousePassiveMove(int x, int y);

	virtual void reshape(int w, int h);

	virtual void idle() ;
	virtual void display() ;

	virtual void init();


	void perspectiveGL( GLdouble fovY, GLdouble aspect, GLdouble zNear, GLdouble zFar );

	void updateObstacles();


	void dispProd();
	void dispBecher();

	///////
	void triKernel(int i, float *datain, float *dataout);
	void tri(int size, float *datain, float *dataout);
	void triStep(int size, int n, float *data[2]);
	void merge(int size, float *datain0, float *datain1, float *dataout);

public:

	GLAppParallelSort(const char *title, int w, int h, int flags = 0);

};

#endif
