#include "ShaderObject.h"

#include <fstream>
#include <string>
#include <iostream>
#include <stdlib.h>


std::string ShaderObject::loadSource(const char *name){
  std::string buff;
  
  std::ifstream file;


  const char* path = getenv("SHADER_DATA_ROOT");
 
  std::string filename;
  if(path!=0) filename = path;
  else filename = ".";
  filename += "/";
  filename += name;

  std::cerr.flush();

  file.open(filename.c_str());
  std::string line;
  while(std::getline(file, line))
    buff += line + "\n";

  return buff;
}

bool ShaderObject::isFileName(const char *str, const char *ext){
	return str && ext && !strcmp(&str[strlen(str)-strlen(ext)], ext);
}


//////////////////
std::string &ShaderObject::getShaderSource(){
  return shaderSource;
}

void ShaderObject::setShaderSource(const char *src, const char *entryfunc){
  if(this->isCorrectFileName(src))
    shaderSource=loadSource(src);
  else
    shaderSource=src;

  shaderSourceEntry=entryfunc;
}

/////////////////////
/////////////////////