#include <iostream>
using namespace std;

#include <flowvr/module.h>
using namespace flowvr;

int main(int argc, char* argv[]) {

  vector<Port*> ports;
  ModuleAPI* module;

  int localsize;
  const int* localtab;
  int* tab;

  InputPort* inport = new InputPort("inputtab");
  ports.push_back(inport);


  OutputPort* outport = new OutputPort("outputtab");
  ports.push_back(outport);

  module = flowvr::initModule(ports);

  if(module) {

    Message messagein;

    MessageWrite messageout;



    while(module->wait()) {

      //Rcupration du tableau global
      module->get(inport, messagein);

      //Tu rcuperes la taille du tableau en octets donc division par sizeof(int)
      localsize = messagein.data.getSize()/sizeof(int);

      cout << "localsize=" << localsize << endl;

      //Recuperation d'un pointeur vers les donnes recues (attention const int*)
      localtab = messagein.data.getRead<int>(0);

      for(int i=0 ; i<localsize ; i++) {
	cout << localtab[i];
      }
      cout << endl;

      //Tu dois allouer une zone memoire pour le message a emettre (le tableau trie)
      messageout.data=module->alloc(localsize*sizeof(int));

      //Ensuite tu peux ecrire dedans et manipuler le contenu avec le tri.
      tab = messageout.data.getWrite<int>(0);

      //Envoi du tableau global
      module->put(outport, messageout);

     
      }

    module->close();
  }
  else {
    cerr << "Erreur d'initialisation" << endl;
  }

  return 0;

}
